function MenuItem(name,color,callback,args)
{
  this.name = name;
  this.color = color;
  this.callback = callback;
  this.args = (args.length > 0) ? args : undefined;
}

//////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////

function Menu()
{
  if (this instanceof Menu == false) {
    return new Menu();
  }

  // default properties
  this.font            = GetSystemFont()
  this.window_style    = LoadWindowStyle("pine.rws");
  this.arrow           = GetSystemArrow();
  this.up_arrow        = GetSystemUpArrow();
  this.down_arrow      = GetSystemDownArrow();
  this.escape_function = function() { }
  
  this.selection = 0;
  this.top_selection = 0;

  this.items = new Array();
}

//////////////////////////////////////////////////////////////////////////////////////////

Menu.prototype.addItem = function(name, color, callback)
{
  var args = new Array;
  for(var Lp0=Menu.prototype.addItem.length; Lp0<Menu.prototype.addItem.arguments.length; ++Lp0)
  {
    if(Menu.prototype.addItem.arguments[Lp0] == undefined)
      break;
    args.push(Menu.prototype.addItem.arguments[Lp0]);
  }

  this.items.push(new MenuItem(name,color,callback,args));
}

//////////////////////////////////////////////////////////////////////////////////////////

Menu.prototype.SetDisplay = function(DisplayType) 
{
 Menu.display = DisplayType; 
}

//////////////////////////////////////////////////////////////////////////////////////////

Menu.prototype.execute = function(x, y, w, h) {
  with (this) {
    if(items.length == 0)
      return;

    var background = GrabImage(0, 0, GetScreenWidth(), GetScreenHeight());

    var text_height = font.getHeight();
    var shown_items = Math.floor(h / text_height);

    selection = 0;
    top_selection = 0;

    while (true) {
      // draw background
      background.blit(0, 0);

      // draw the window
      window_style.drawWindow(x, y, w, h);

      // draw the menu items
      for (var i = 0; i < shown_items; i++) {
        if (i < items.length) {
          font.setColorMask(Black);
          font.drawText(x + 16 + 1, y + i * text_height + 1, items[i + top_selection].name);
          font.setColorMask(items[i + top_selection].color);
          font.drawText(x + 16,     y + i * text_height,     items[i + top_selection].name);
        }
      }

      // draw the selection arrow
      arrow.blit(x, y + (selection - top_selection) * text_height);

      // draw the up and down arrows if necessary
      if (top_selection > 0) {
        up_arrow.blit(x + w - up_arrow.width, y);
      }
      if (top_selection + shown_items < items.length) {
        down_arrow.blit(x + w - down_arrow.width, y + text_height * shown_items - down_arrow.height);
      }

      FlipScreen();

      // handle keypresses
      while (AreKeysLeft()) {
        switch (GetKey()) {
          case KEY_ENTER:
          {
             return items[selection].callback(items[selection].args);
          } break;

          case KEY_ESCAPE: {
            return escape_function();
          } break;

          case KEY_DOWN: {
            if (selection < items.length - 1) {
              selection++;
              if (selection >= top_selection + shown_items) {
                top_selection++;
              }
            }
            break;
          }

          case KEY_UP: {
            if (selection > 0) {
              selection--;
              if (selection < top_selection) {
                top_selection--;
              }
            }
            break;
          }

        }
      } // end handle input
    }

  } // end with
}

