function SDemoOne()
{
  /* Sphere Demo One: Surface Tricks */
  // No known issues.
  // SD1S3 works best running at 60fps or higher.
  // SD1S4 is S3, but runs at at little bit more than half the fps, but won't look fugly
  //       at low resolutions.
  var iGradient = LoadSurface("Gradient.png");
  var sw = GetScreenWidth(), sh = GetScreenHeight();
  var font = GetSystemFont();
  var theta = 0, deg = 0;  
  var buffer = CreateSurface(sw, sh, CreateColor(0, 0, 0)); //Setup a buffer to hold the screen.
  buffer.setAlpha(192); //Sets all blits to 192% alpha.
  for (var step = 0; step < 5; step++) {
    while (!IsKeyPressed(KEY_ENTER)) {
      var mx = GetMouseX(), my = GetMouseY();
      buffer.line(sw * 2/5, sh / 2, sw * 3/5, sh / 2, CreateColor(255, 255, 255, 255)); //This makes the + in the center.
      buffer.line(sw / 2, sh * 2/5, sw / 2, sh * 3/5, CreateColor(255, 255, 255, 255));
      if (!IsKeyPressed(KEY_Z))
        buffer.blitSurface(iGradient, mx - 8, my - 8); //Blits the cursor
      if (step >= 2)
        buffer.blitSurface(buffer, Sin( theta ), -Cos( theta )); //Blits the surface *onto* itself, remember this blits at
                                                                 //192% alpha and blits slightly offset because of the sin/cos
      theta += Math.PI/90; deg = theta * Math.PI * 180; //Increase the rotation by 2 degrees
      if (step >= 3) 
        buffer.rotate(Math.PI, false); //mmmm...rotation.
      if (step >= 4) {
        buffer.blitSurface(buffer, Sin( theta ), -Cos( theta ));
        buffer.rotate(Math.PI, false);
      }
      if (step >= 1)
        c = CreateColor(128*Cos(deg/20)+128, 128*Sin(deg/25)+128, 64*Cos(deg/17)+128);
      else
        c = CreateColor(255, 255, 255);
      buffer.setAlpha(255);      
      buffer.createImage().blitMask(0, 0, c);
      buffer.setAlpha(128);
      font.drawText(0, 0, "[Enter to continue] SD1S"+step.toLocaleString()+": Surface Tricks");
      DrawFPS();      
      FlipScreen();
    }
    while (IsKeyPressed(KEY_ENTER)) {}
      //FlipScreen();
  }
}
