EvaluateScript("system.js");
EvaluateScript("talk.js");
EvaluateScript("menu.js");

var CrystalInParty;
var SullyKnowsSomething;
var SullyIsScared;

function map_viewer()
{
  var x, y, ox, oy;
  x = GetCameraX();
  y = GetCameraY();
  ox = x;
  oy = y;

  while (AreKeysLeft()) {
    switch (GetKey()) {
    
    case KEY_UP: y--; break;
    case KEY_DOWN: y++; break;
    case KEY_LEFT: x--; break;
    case KEY_RIGHT: x++; break;
    }
  }
  
  if (ox != x) SetCameraX(x);
  if (oy != y) SetCameraY(y);
}

function camera_render()
{
  var x = GetCameraX();
  var y = GetCameraY();
  
  system_font_small.drawText(0, 0, "Camera: (" + x + "," + y + ")");
}

function Island_EnterMap()
{
  CrystalInParty      = register[0];
  SullyKnowsSomething = register[1];
  SullyIsScared       = register[2];
  //BindKey(KEY_ENTER, "mainMenu();", "");
  CreatePerson("Sully", "sully.rss", true);
  SetPersonX("Sully", 4 * 16 + 8);
  SetPersonY("Sully", 3 * 16 + 10);
  SetPersonLayer("Sully", 0);
  SetPersonScript("Sully", 3, "SullyTalk();");
  
  if (CrystalInParty != true)
  {
    SetPersonX("Crystal", 46 * 16 + 8);
    SetPersonY("Crystal", 26 * 16 + 8);
    SetPersonLayer("Crystal", 0);
    SetPersonScript("Crystal", 3, "CrystalTalk();");
  }
  
  //SetCameraX(479);
  //SetFrameRate(9000);
  SetRenderScript("camera_render();");
  //SetUpdateScript("map_viewer();");
}

function Island_ExitMap()
{
  register[0] = CrystalInParty;
  register[1] = SullyKnowsSomething;
  register[2] = SullyIsScared;
}

//////////////////////////////////////////////////////////////////////

function SullyTalk()
{
  if (!SullyKnowsSomething)
    SullyWelcome();
  else if (SullyIsScared)
    SullyScared();
  else
    SullyKnowsWhereThePearlIs();
}

function SullyWelcome()
{
  PTalk(0, "Darin, my man! Sully Clam here! What's up with my main homey today bro?");
  PTalk(1, "Hi Sully! I have this strange feeling that we ain't in Kansas anymore...");
  PTalk(0, "Well... That's because we're undergoing some new management. ");
  PTalk(0, "We were picked up by some crazed ex-Verger who decided that this would be a really");
  PTalk(0, "good way to test another RPG maker.");
  PTalk(1, "That probably explains why I can walk diagonally and feeling more colorful than");
  PTalk(1, "usual.");
  PTalk(0, "... uh yeah. About a few bits of the world is currently working, at least Sara isn't");
  PTalk(0, "gonna bust your ass for Crystal. Bwhahahahah!");
  PTalk(1, "Who's Sara?");
  PTalk(0, "Your crazy stalking ex-girlfriend.");
  PTalk(1, "But I don't have an ex...");
  PTalk(0, "You will soon. hahaaa!");
  PTalk(0, "That's about it, go save the world dude!");
}

function SullyScared()
{
  PTalk(0, "Please leave me be. I'm just a silly little clam. I have no objects of value for you!");
}

function SullyKnowsWhereThePearlIs()
{
  PTalk(0, "Hi! My name is Sully Clam. I welcome you back to Paradise Isle.");
  PTalk(5, "Enough small talk, clam. Tell us where to find the Pearl of Truth before I rough you up!");
  PTalk(2, "I thought Pearls came from oysters, not clams.");
  PTalk(4, "Sully, is there something you haven't told us?");
  PTalk(0, "Alright, I give up! The ancient race of cyclops once lived on this island.");
  PTalk(0, "There's a sacred hall beneath here that holds the Pearl of Truth.");
  PTalk(5, "Grand! Show us the entrance or I'll teach you a whole new meaning of shellfish abuse!");
  PTalk(0, "Okee dokee. Let me just try to remember the location...");
  PTalk(5, "Stop stalling, clam! I need to get back inside the Castle Heck right away!");
  // TODO: change tile here!
  PTalk(0, "Oh, I remember! I's near the lagoon between the tree. I have revealed the entrance!");
  PTalk(1, "Thanks, Sully. We owe ya one!");
}

function CrystalTalk()
{
  // stupidity check ;)
  if (CrystalInParty == 1) return;
  else CrystalInParty = 1;

  Delay(200);
  FadeOut(300);
  var crystalPic = LoadImage("cryssand.pcx");
  ClearScreen();
  crystalPic.blit(170, 1);
  FadeIn(300);
  
  PTalk(4, "Darin... Hello. How are you today? I needed to talk to you about something...");
  PTalk(4, "I... I've been thinking and I've decided we need to leave Paradise Island.");
  
  var darinPic = LoadImage("darin01.pcx");
  darinPic.blit(40, 1);
  
  PTalk(1, "But Crystal! What's wrong? I kinda like this blue lagoon thing we have going on.");
  PTalk(4, "No... it has to be this way. We'll go insane if we don't have some adventure soon.");
  PTalk(1, "I suppose you're right. I'd like to go exploring some caves and stuff.");
  
  FadeOut(300);
  RenderMap();
  FadeIn(300);
  
  PTalk(4, "I'm glad you understand. I suppose we can use the undersea passage. Let's go!");


  for (var x=0; x<16; x++)
  {
    QueuePersonCommand("Crystal", COMMAND_MOVE_SOUTH, false);
    UpdateMapEngine();
    RenderMap();
    FlipScreen();
  }
  Delay(100);
  FollowPerson("Crystal", "Darin", 18);
}

function WarpToUndersea()
{
  MapChange("undersea.rmp", "Darin", 13, 2);
}