EvaluateScript("system.js");
EvaluateScript("talk.js");
//EvaluateScript("party.js");
EvaluateScript("island.js");
//EvaluateScript("menu.js");

function game()
{
  initSystem();
  
  // put a loading sequence?
  system_font_small.drawText(
     320 - system_font_small.getStringWidth("Loading..."), 
     200 - system_font_small.getHeight(),
     "Loading...");
  FlipScreen();
  
  //BindKey(KEY_SPACE, "mainMenu();", "");
  //initSoundSystem();
  //initPartySystem();
  //startupMusic();
  //startup();
  //startupMenu();
  startGame();
}

////////////////////////////////////////////////////////////////////

function startupMusic()
{
  system_music = LoadSound("Aurora.mod");
  system_music.play(true);
}

////////////////////////////////////////////////////////////////////

function startup()
{
  var vergeLogo  = LoadImage("Verge320.pcx");
  var gameSplash = LoadImage("Verge1.pcx");

  // the intro intro ;)
  vergeLogo.blit(0, 0);
  FadeIn(500);
  Delay(800);
  FadeOut(500);

  gameSplash.blit(0, 0);
  FadeIn(500);
  Delay(800);
}

////////////////////////////////////////////////////////////////////

function startupMenu()
{
  var gameSplash = LoadImage("Verge1.pcx");
  var menusound = LoadSound("Menumove.wav");
  
  // the startup menu
  var done = false;
  var value = 1;
  
  while (!done)
  {
    gameSplash.blit(0, 0);
    system_window.drawWindow(86, 76, 148, 48);
    system_font_small.drawText(115, 86, "New Game");
    system_font_small.drawText(115, 96, "Load Game");
    system_font_small.drawText(115, 106, "Exit to DOS");
    system_pointer.blit(94, value * 10 + 74);
    FlipScreen();

    while(AreKeysLeft())
      switch(GetKey())
      {
        case KEY_ENTER: done = true;                    break;
        case KEY_DOWN:  value++; menusound.play(false); break;
        case KEY_UP:    value--; menusound.play(false); break;
      }

    if (value < 1) value = 3;
    if (value > 3) value = 1;
  }

  switch(value)
  {
    case 1: startGame(); break;
    case 2: Abort("Nope. Not Implemented."); break;
    case 3: Exit(); break;
  }
  
  Exit();
}

////////////////////////////////////////////////////////////////////

function startGame()
{
  //intro();
  //system_music.stop();

  CreatePerson("Darin", "darin.rss", false);
  CreatePerson("Crystal", "crystal.rss", false);
  //FollowPerson("Crystal", "Darin", 18);
  AttachInput("Darin");
  AttachCamera("Darin");
  MapEngine("island.rmp", 75);
}

////////////////////////////////////////////////////////////////////

function intro()
{
  // slow down the framerate otherwise this will go too fast!
  SetFrameRate(15);
  
  var island = LoadImage("Island.PCX");
  for (var i=0; i<475; i++)
  {
    ClearScreen();
    island.blit(80, 50);
    DrawCText(200 - i, "Our world is but one in the universe.");
    DrawCText(225 - i, "The imagination is vast and limitless.");
    DrawCText(250 - i, "An astral force known as VERGE allows");
    DrawCText(275 - i, "us to shape our dreams into reality.");
    DrawCText(300 - i, "Darin's is but one small world in the");
    DrawCText(325 - i, "endless reaches of space. Darin sailed");
    DrawCText(350 - i, "from his home in seach of a new world,");
    DrawCText(375 - i, "but alas, he found each of the worlds");
    DrawCText(400 - i, "still undergoing contruction. Sad, yet");
    DrawCText(425 - i, "hopeful, Darin returns to spend time");
    DrawCText(450 - i, "in peace with his eternal soulmate...");
    
    FlipScreen();
  }

  // set the rate rate back to 60 and fade out
  SetFrameRate(0);
  island.blit(80, 50);
  FadeOut(400);

  ClearScreen();
  DrawCText(82, "- VERGE -");
  DrawCText(110, "The Sully Chronicles");
  FadeIn(1200);
  Delay(3000);
  FadeOut(1200);
}

////////////////////////////////////////////////////////////////////

function DrawCText(y, text)
{
  // formula for offset = (width of screen - string of text) / 2;
  var offset = (320 - system_font_small.getStringWidth(text)) / 2;
  
  system_font_small.drawText(offset, y, text);
}

