var Gold;         // gold in party
var PartyIndex;   // character stats in the party
var Char;         // Character Stats

////////////////////////////////////////////////////////////////////

function PartyFromINI()
{
  var total_characters;

  party_ini = OpenFile("party.ini");
  total_characters = party_ini.read("NumberOfChars", -1);
  Char = new Array();
  
  for (var i=0; i<total_characters; i++)
  {
    var char_ini = party_ini.read("Char" + i + " - INI", "aaa");
    Char[i] = new CharacterFromINI(char_ini + ".ini");
  }
}

////////////////////////////////////////////////////////////////////

function PartyFromDAT()
{
  var total_characters;
  var data_dump;
  var party_dat;
  var num_char_struct;
  var offset = 0;
  
  Char = new Array();
  party_dat = OpenRawFile("party.dat");
  data_dump = party_dat.read(party_dat.getSize());
  
  // get the number of characters
  num_char_struct = grabStringFromDat(data_dump, offset);
  total_characters = parseInt(num_char_struct.text);
  offset = num_char_struct.offset;
  
  // prepare for the party.ini
  //var f = OpenFile("party.ini");
  //f.write("NumberOfChars", total_characters);
  
  for (var i=0; i<total_characters; i++)
  {
    var spritefile   = grabStringFromDat(data_dump, offset);
    var portraitfile = grabStringFromDat(data_dump, spritefile.offset);
    var spritedatfile= grabStringFromDat(data_dump, portraitfile.offset);
    offset = spritedatfile.offset;
    
    var sprite_dat   = OpenRawFile(spritedatfile.text);
    var spr_data_dump= sprite_dat.read(sprite_dat.getSize() - 1);
    Char[i] = new CharacterFromDAT(spritefile.text, portraitfile.text, spr_data_dump);
    
    //Char[i].dumpINI();
    //f.write("Char" + i + " - INI", Char[i].name);
    //Debug(Char[i].name);
  }
 
  //Debug("software quitting: - dumped DAT files -> INI files");
  //Exit();
}

////////////////////////////////////////////////////////////////////

function CharacterFromINI(sprite_name)
{
  var f = OpenFile(sprite_name);
  this.name          = f.read("name", "aaa");
  this.sprite_file   = f.read("sprite", "aaa");
  this.portrait_file = f.read("portrait", "aaa");
  this.portrait      = LoadCR2(this.portrait_file);
  var numOfLevels    = f.read("levels", -1);
  this.level_dat = new Array();

  // read the initial level data;
  var level = 0;
  {
    this.level_dat[level]       = new Object();
    this.level_dat[level].exp   = f.read("lvl: 0 - exp",   -1);
    this.level_dat[level].maxHP = f.read("lvl: 0 - maxHP", -1);
    this.level_dat[level].maxMP = f.read("lvl: 0 - maxMP", -1);
    this.level_dat[level].str   = f.read("lvl: 0 - str",   -1);
    this.level_dat[level].end   = f.read("lvl: 0 - end",   -1);
    this.level_dat[level].mag   = f.read("lvl: 0 - mag",   -1);
    this.level_dat[level].mgr   = f.read("lvl: 0 - mgr",   -1);
    this.level_dat[level].hit   = f.read("lvl: 0 - hit",   -1);
    this.level_dat[level].dod   = f.read("lvl: 0 - dod",   -1);
    this.level_dat[level].mbl   = f.read("lvl: 0 - mbl",   -1);
    this.level_dat[level].fer   = f.read("lvl: 0 - fer",   -1);
    this.level_dat[level].rea   = f.read("lvl: 0 - rea",   -1);
    this.level_dat[level].spell = f.read("lvl: 0 - spell", -1);
  }
/*
  // read the rest of the level data;
  for (level=1; level<numOfLevels; level++)
  {
    this.level_dat[level]          = new Object();
    this.level_dat[level].exp      = f.read("lvl: " + level + " - exp",      -1);
    this.level_dat[level].maxHP_lo = f.read("lvl: " + level + " - maxHP_lo", -1);
    this.level_dat[level].maxHP_hi = f.read("lvl: " + level + " - maxHP_hi", -1);
    this.level_dat[level].maxMP_lo = f.read("lvl: " + level + " - maxMP_lo", -1);
    this.level_dat[level].maxMP_hi = f.read("lvl: " + level + " - maxMP_hi", -1);
    this.level_dat[level].str_lo   = f.read("lvl: " + level + " - str_lo",   -1);
    this.level_dat[level].str_hi   = f.read("lvl: " + level + " - str_hi",   -1);
    this.level_dat[level].end_lo   = f.read("lvl: " + level + " - end_lo",   -1);
    this.level_dat[level].end_hi   = f.read("lvl: " + level + " - end_hi",   -1);
    this.level_dat[level].mag_lo   = f.read("lvl: " + level + " - mag_lo",   -1);
    this.level_dat[level].mag_hi   = f.read("lvl: " + level + " - mag_hi",   -1);
    this.level_dat[level].mgr_lo   = f.read("lvl: " + level + " - mgr_lo",   -1);
    this.level_dat[level].mgr_hi   = f.read("lvl: " + level + " - mgr_hi",   -1);
    this.level_dat[level].hit_lo   = f.read("lvl: " + level + " - hit_lo",   -1);
    this.level_dat[level].hit_hi   = f.read("lvl: " + level + " - hit_hi",   -1);
    this.level_dat[level].dod_lo   = f.read("lvl: " + level + " - dod_lo",   -1);
    this.level_dat[level].dod_hi   = f.read("lvl: " + level + " - dod_hi",   -1);
    this.level_dat[level].mbl_lo   = f.read("lvl: " + level + " - mbl_lo",   -1);
    this.level_dat[level].mbl_hi   = f.read("lvl: " + level + " - mbl_hi",   -1);
    this.level_dat[level].fer_lo   = f.read("lvl: " + level + " - fer_lo",   -1);
    this.level_dat[level].fer_hi   = f.read("lvl: " + level + " - fer_hi",   -1);
    this.level_dat[level].rea_lo   = f.read("lvl: " + level + " - rea_lo",   -1);
    this.level_dat[level].rea_hi   = f.read("lvl: " + level + " - rea_hi",   -1);
    this.level_dat[level].spell    = f.read("lvl: " + level + " - spell",    -1);
  }
*/  
}

////////////////////////////////////////////////////////////////////

function CharacterFromDAT(sprite_file, portrait_file, sprite_dat)
{
  // do the obvious first ;)
  this.sprite_file   = sprite_file;
  this.portrait_file = portrait_file;
  this.portrait      = LoadCR2(portrait_file);
  
  // now process the sprite dat
  var char_name = grabStringFromDat(sprite_dat, 0);
  this.name = char_name.text;
  var blah = grabStringFromDat(sprite_dat, char_name.offset);
  for (var i=1; i<13; i++)
    blah = grabStringFromDat(sprite_dat, blah.offset);

  
  // get the initial level data;
  this.level_dat = new Array();
  var info = new Object();
  info.offset = blah.offset;
  var level = 0;
  {
    this.level_dat[level] = new Object;
    
    info = grabStringFromDat(sprite_dat, info.offset);
    this.level_dat[level].exp      = parseInt(info.text);  info = grabStringFromDat(sprite_dat, info.offset);
    this.level_dat[level].maxHP    = parseInt(info.text);  info = grabStringFromDat(sprite_dat, info.offset);
    this.level_dat[level].maxMP    = parseInt(info.text);  info = grabStringFromDat(sprite_dat, info.offset);
    this.level_dat[level].str      = parseInt(info.text);  info = grabStringFromDat(sprite_dat, info.offset);
    this.level_dat[level].end      = parseInt(info.text);  info = grabStringFromDat(sprite_dat, info.offset);
    this.level_dat[level].mag      = parseInt(info.text);  info = grabStringFromDat(sprite_dat, info.offset);
    this.level_dat[level].mgr      = parseInt(info.text);  info = grabStringFromDat(sprite_dat, info.offset);
    this.level_dat[level].hit      = parseInt(info.text);  info = grabStringFromDat(sprite_dat, info.offset);
    this.level_dat[level].dod      = parseInt(info.text);  info = grabStringFromDat(sprite_dat, info.offset);
    this.level_dat[level].mbl      = parseInt(info.text);  info = grabStringFromDat(sprite_dat, info.offset);
    this.level_dat[level].fer      = parseInt(info.text);  info = grabStringFromDat(sprite_dat, info.offset);
    this.level_dat[level].rea      = parseInt(info.text);  info = grabStringFromDat(sprite_dat, info.offset);
    this.level_dat[level].spell    = parseInt(info.text);

    level++;
  }

  // grab the level data;
  var done = false;
  while (done != true)
  {
    this.level_dat[level] = new Object;
    
    var previous = new Object();
    previous.offset = info.offset;
    info = grabStringFromDat(sprite_dat, info.offset);
    if (previous.offset == info.offset)
    {
      done = true; 
      break; 
    }
    
    this.level_dat[level].exp      = parseInt(info.text);  info = grabStringFromDat(sprite_dat, info.offset);
    this.level_dat[level].maxHP_lo = parseInt(info.text);  info = grabStringFromDat(sprite_dat, info.offset);
    this.level_dat[level].maxHP_hi = parseInt(info.text);  info = grabStringFromDat(sprite_dat, info.offset);
    this.level_dat[level].maxMP_lo = parseInt(info.text);  info = grabStringFromDat(sprite_dat, info.offset);
    this.level_dat[level].maxMP_hi = parseInt(info.text);  info = grabStringFromDat(sprite_dat, info.offset);
    this.level_dat[level].str_lo   = parseInt(info.text);  info = grabStringFromDat(sprite_dat, info.offset);
    this.level_dat[level].str_hi   = parseInt(info.text);  info = grabStringFromDat(sprite_dat, info.offset);
    this.level_dat[level].end_lo   = parseInt(info.text);  info = grabStringFromDat(sprite_dat, info.offset);
    this.level_dat[level].end_hi   = parseInt(info.text);  info = grabStringFromDat(sprite_dat, info.offset);
    this.level_dat[level].mag_lo   = parseInt(info.text);  info = grabStringFromDat(sprite_dat, info.offset);
    this.level_dat[level].mag_hi   = parseInt(info.text);  info = grabStringFromDat(sprite_dat, info.offset);
    this.level_dat[level].mgr_lo   = parseInt(info.text);  info = grabStringFromDat(sprite_dat, info.offset);
    this.level_dat[level].mgr_hi   = parseInt(info.text);  info = grabStringFromDat(sprite_dat, info.offset);
    this.level_dat[level].hit_lo   = parseInt(info.text);  info = grabStringFromDat(sprite_dat, info.offset);
    this.level_dat[level].hit_hi   = parseInt(info.text);  info = grabStringFromDat(sprite_dat, info.offset);
    this.level_dat[level].dod_lo   = parseInt(info.text);  info = grabStringFromDat(sprite_dat, info.offset);
    this.level_dat[level].dod_hi   = parseInt(info.text);  info = grabStringFromDat(sprite_dat, info.offset);
    this.level_dat[level].mbl_lo   = parseInt(info.text);  info = grabStringFromDat(sprite_dat, info.offset);
    this.level_dat[level].mbl_hi   = parseInt(info.text);  info = grabStringFromDat(sprite_dat, info.offset);
    this.level_dat[level].fer_lo   = parseInt(info.text);  info = grabStringFromDat(sprite_dat, info.offset);
    this.level_dat[level].fer_hi   = parseInt(info.text);  info = grabStringFromDat(sprite_dat, info.offset);
    this.level_dat[level].rea_lo   = parseInt(info.text);  info = grabStringFromDat(sprite_dat, info.offset);
    this.level_dat[level].rea_hi   = parseInt(info.text);  info = grabStringFromDat(sprite_dat, info.offset);
    this.level_dat[level].spell    = parseInt(info.text);
    
    level++;
  }
  
  this.dumpINI = dumpINI;
}

////////////////////////////////////////////////////////////////////

function dumpINI()
{
  var f = OpenFile(this.name + ".ini");
  
  // do the obvious first ;)
  f.write("name",     this.name);
  f.write("sprite",   this.sprite_file);
  f.write("portrait", this.portrait_file);
  f.write("levels",   this.level_dat.length);

  // dump the initial level data;
  var level = 0;
  {
    f.write("lvl: 0 - exp",   this.level_dat[level].exp);
    f.write("lvl: 0 - maxHP", this.level_dat[level].maxHP);
    f.write("lvl: 0 - maxMP", this.level_dat[level].maxMP);
    f.write("lvl: 0 - str",   this.level_dat[level].str);
    f.write("lvl: 0 - end",   this.level_dat[level].end);
    f.write("lvl: 0 - mag",   this.level_dat[level].mag);
    f.write("lvl: 0 - mgr",   this.level_dat[level].mgr);
    f.write("lvl: 0 - hit",   this.level_dat[level].hit);
    f.write("lvl: 0 - dod",   this.level_dat[level].dod);
    f.write("lvl: 0 - mbl",   this.level_dat[level].mbl);
    f.write("lvl: 0 - fer",   this.level_dat[level].fer);
    f.write("lvl: 0 - rea",   this.level_dat[level].rea);
    f.write("lvl: 0 - spell", this.level_dat[level].spell);
  }

  // dump the level data;
  for (level=1; level<this.level_dat.length; level++)
  {
    f.write("lvl: " + level + " - exp",      this.level_dat[level].exp);
    f.write("lvl: " + level + " - maxHP_lo", this.level_dat[level].maxHP_lo);
    f.write("lvl: " + level + " - maxHP_hi", this.level_dat[level].maxHP_hi);
    f.write("lvl: " + level + " - maxMP_lo", this.level_dat[level].maxMP_lo);
    f.write("lvl: " + level + " - maxMP_hi", this.level_dat[level].maxMP_hi);
    f.write("lvl: " + level + " - str_lo",   this.level_dat[level].str_lo);
    f.write("lvl: " + level + " - str_hi",   this.level_dat[level].str_hi);
    f.write("lvl: " + level + " - end_lo",   this.level_dat[level].end_lo);
    f.write("lvl: " + level + " - end_hi",   this.level_dat[level].end_hi);
    f.write("lvl: " + level + " - mag_lo",   this.level_dat[level].mag_lo);
    f.write("lvl: " + level + " - mag_hi",   this.level_dat[level].mag_hi);
    f.write("lvl: " + level + " - mgr_lo",   this.level_dat[level].mgr_lo);
    f.write("lvl: " + level + " - mgr_hi",   this.level_dat[level].mgr_hi);
    f.write("lvl: " + level + " - hit_lo",   this.level_dat[level].hit_lo);
    f.write("lvl: " + level + " - hit_hi",   this.level_dat[level].hit_hi);
    f.write("lvl: " + level + " - dod_lo",   this.level_dat[level].dod_lo);
    f.write("lvl: " + level + " - dod_hi",   this.level_dat[level].dod_hi);
    f.write("lvl: " + level + " - mbl_lo",   this.level_dat[level].mbl_lo);
    f.write("lvl: " + level + " - mbl_hi",   this.level_dat[level].mbl_hi);
    f.write("lvl: " + level + " - fer_lo",   this.level_dat[level].fer_lo);
    f.write("lvl: " + level + " - fer_hi",   this.level_dat[level].fer_hi);
    f.write("lvl: " + level + " - rea_lo",   this.level_dat[level].rea_lo);
    f.write("lvl: " + level + " - rea_hi",   this.level_dat[level].rea_hi);
    f.write("lvl: " + level + " - spell",    this.level_dat[level].spell);
  }
  
  Debug("dumped out ini for " + this.name);
}

////////////////////////////////////////////////////////////////////

function initPartySystem()
{
  // maybe use a debug mode?
  //PartyFromDAT();
  PartyFromINI();
  PartyIndex = new Array();
  PartyIndex[0] = 0;
  PartyIndex[1] = 3;
  
  Char[0].exp = 0;
  Char[0].rea = 0;
  Char[0].curhp = 0;
  Char[0].maxhp = 0;
  Char[0].curmp = 0;
  Char[0].maxmp = 0;
  Char[0].atk = 0;
  Char[0].def = 0;
  Char[0].str = 0;
  Char[0].end = 0;
  Char[0].mag = 0;
  Char[0].mgr = 0;
  Char[0].hit = 0;
  Char[0].dod = 0;
  Char[0].mbl = 0;
  Char[0].fer = 0;
  Char[0].magc = 0;
  Char[0].mgrc = 0;
  Char[0].hitc = 0;
  Char[0].dodc = 0;
  Char[0].mblc = 0;
  Char[0].ferc = 0;
  Char[0].reac = 0;
  Char[0].nxt = 0;
  Char[0].lv  = 1;
  Char[0].status = 0;
  Char[0].invcnt = 0;
  Char[0].inv = Array(24);

  Char[3].exp = 0;
  Char[3].rea = 0;
  Char[3].curhp = 0;
  Char[3].maxhp = 0;
  Char[3].curmp = 0;
  Char[3].maxmp = 0;
  Char[3].atk = 0;
  Char[3].def = 0;
  Char[3].str = 0;
  Char[3].end = 0;
  Char[3].mag = 0;
  Char[3].mgr = 0;
  Char[3].hit = 0;
  Char[3].dod = 0;
  Char[3].mbl = 0;
  Char[3].fer = 0;
  Char[3].magc = 0;
  Char[3].mgrc = 0;
  Char[3].hitc = 0;
  Char[3].dodc = 0;
  Char[3].mblc = 0;
  Char[3].ferc = 0;
  Char[3].reac = 0;
  Char[3].nxt = 0;
  Char[3].lv  = 1;
  Char[3].status = 0;
  Char[3].invcnt = 0;
  Char[3].inv = Array(24);
  
  Gold = 100;
}

////////////////////////////////////////////////////////////////////

function isInParty(char_num)
{
  return true;
}
