
/*
*This function animates a character falling.
*A shadow is put where the Entity will land at.
*Input: character name, distance fallen (in pixels), rate in which they fall(pixels)
*Output: show character fall
*/

var shadow = LoadImage("chr_shadow.png");
//var shadow = LoadImage("chr_shadow.png");

function EntityFall(name,distance, rate)
{
   var entY = GetPersonY(name);
   var entX = GetPersonX(name);
   var entL = GetPersonLayer(name);
   
   SetPersonLayer(name, entL + 1);
   
   shadow_distance = distance + entY;
   
   SetLayerRenderer(entL, "shadow.blit("+entX +"-8," + shadow_distance  + "-8);");

   for(var i = 0;i < distance; i += rate)
   {
     RenderMap();
  
     //shadow.blit(entX-8, entY-8+distance);
     SetPersonDirection(name, 8);
     SetPersonFrame(name,0);
     SetPersonY(name,entY + i);
     FlipScreen();   
   }
   
   //move any extra pixels if the while loop didn't get it
   if(i < distance)
   {
     RenderMap();
     SetPersonY(name,distance - entY);
     FlipScreen();    
   }
   
   
   SetLayerRenderer(entL, "");
   SetPersonLayer(name, entL);
}


function EntityJump(name,length, height)
{
   var entY = GetPersonY(name);
   var entX = GetPersonX(name);
   var entL = GetPersonLayer(name);
   
   SetPersonLayer(name, entL + 1);
   
   shadow_distance =  entY;
   
   SetLayerRenderer(entL, "shadow.blit("+entX +"-8," + shadow_distance  + "-8);");

   for(var i = 0; i < length; i++)
   {
     RenderMap();
  
     SetPersonDirection(name, 8);
     SetPersonFrame(name,0);
     SetPersonX(name,entX + i);
     FlipScreen();
     i += 1;   
   }
   
   //move any extra pixels if the while loop didn't get it
   if(i < distance)
   {
     RenderMap();
     SetPersonY(name,length - entY);
     FlipScreen();    
   }
   
   
   SetLayerRenderer(entL, "");
   SetPersonLayer(name, entL);
}
