//LABEL!

function Label (x,y,w,h,multiline,text,font)
{
  Skeleton.call(this);
  this.x=x;
  this.y=y;
  this.w=w;
  this.h=h;
  this.offset=0;
  this.text=text;
  this.font=font;
  this.valine=false;
  this.multiline=multiline;
  this.depressed=false; //Looks only.
  this.hilight=CreateColor(255,255,255);
  this.lolight=CreateColor(0,0,0);
  this.clear=true;
  this.bgcolor=CreateColor(255,255,255);
  if (!font)
  {
   this.font=GetSystemFont();
   this.font.setColorMask(CreateColor(0,0,0));
  }
}

Label.prototype = new Skeleton();

Label.prototype.addLine = function (t)
{
  this.text+="\n"+t;
}

Label.prototype.draw = function ()
{
  with (this)
  {
    if (!clear)
    {
      Rectangle(plotx(0),ploty(0),w,h,bgcolor);
    }
    if (!multiline)
    {
      font.drawText(plotx(0),ploty(0),text);
    }
    else if (!valine)
    {
      font.drawTextBox(plotx(0),ploty(0),w,h,offset,text);
    }
    else
    {
      if (font.getStringHeight(text,w)-h>0) font.drawTextBox(plotx(0)+1,ploty(0)+1,w-2,h-2,-font.getStringHeight(text,w)+h,text);
      else font.drawTextBox(plotx(0)+1,ploty(0)+2,w-2,h-2,0,text);
    }
    
    if (depressed)
    {
      px=plotx(0);
      py=ploty(0);
      Line(px,py,px,py+h,lolight);
      Line(px,py,px+w,py,lolight);
      Line(px+w,py,px+w,py+h,hilight);
      Line(px,py+h,px+w,py+h,hilight);  
    }
  }
}

