var iClose=LoadImage("iClose.png");

function Grey(c)
{
  var b = c.red+c.blue+c.green;
  b=b/3;
  return CreateColor(b,b,b,c.alpha);
}

function Window (x,y,h,w,caption)
{
  Container.call(this);
  this.x=x;
  this.y=y;
  this.h=h;
  this.w=w;
  this.dragging=false;
  this.dragx=0;
  this.dragy=0;
  this.hilight=CreateColor(255,255,255);
  this.lolight=CreateColor(0,0,0);
  this.bgcolor=CreateColor(192,192,192);
  this.cLR=CreateColor(0,0,0);
  this.cUL=CreateColor(255,255,255);
  this.cLL=CreateColor(0,255,0);
  this.cUR=CreateColor(0,255,0);
  this.caption=caption;
  this.font=GetSystemFont();
  this.captionColor=CreateColor(0,0,0);
  this.resizable=true;
  this.minW=this.font.getStringWidth(this.caption);
  this.minH=50;
  this.obj=new Array();
  this.buttonClose=this.attach(new Button(this.w-10,1,9,9,"X"));
  this.buttonClose.mouseOverRaised=true;
  this.buttonClose.image=iClose;
  this.focus=false;
}

Window.prototype = new Container();

Window.prototype.draw = function ()
{

  with (this)
  {
    Rectangle(plotx(0),ploty(0),w,h,bgcolor);
    for (var n=obj.length-1; n>=0; n--)
      {
        if (!obj[n].hidden) obj[n].draw();
      }
    px=plotx(0);
    py=ploty(0);
    if (focus) GradientRectangle(px+1,py+1,w-1,10,cUL,cUR,cLR,cLL);
    else GradientRectangle(px+1,py+1,w-1,10,Grey(cUL),Grey(cUR),Grey(cLR),Grey(cLL));
    font.setColorMask(CreateColor(captionColor.red,captionColor.blue,captionColor.green,128));
    font.drawText(px+2,py+1,caption+"("+dbugn+")("+mmx+","+mmy+")");
    font.setColorMask(captionColor);
    font.drawText(px+1,py+1,caption+"("+dbugn+")("+mmx+","+mmy+")");
    buttonClose.draw();
    Line(px+w,py+h,px+w,py,lolight);
    Line(px+w,py+h,px,py+h,lolight);
    Line(px,py,px+w,py,hilight);
    Line(px,py,px,py+h,hilight);
  }  
}

Window.prototype.__mouseDown = function ()
{
  with (this)
  {
    getKeyFocus(); focus=true;
   
    if (GetMouseX()>plotx(0) && GetMouseX()<plotx(w) &&
     GetMouseY()>ploty(0) && GetMouseY()<ploty(10))
      {
        dragging=true;
        mouse.drag(this);
      }
    else if (GetMouseX()>=plotx(w-2) && 
            GetMouseY()>=ploty(h-2) && resizable)
      {
        dragging=true;
        mouse.useResize(this,true,true,cDiagSize);
      }
    else if (GetMouseX()>=plotx(w-2) && resizable) {this.dragging=true; mouse.useResize(this,true,false,cHorSize);}
    else if (GetMouseY()>=ploty(h-2) && resizable) {this.dragging=true; mouse.useResize(this,false,true,cVertSize);}
  }
}

Window.prototype.__mouseOver = function ()
{
  with (this)
  {
    if (GetMouseX()>plotx(0) && GetMouseX()<plotx(w) &&
     GetMouseY()>ploty(0) && GetMouseY()<ploty(10))
      {
        mouse.img=cDraggable;
      }
   else if (GetMouseX()>=plotx(w-2) &&
      GetMouseY()>=ploty(h-2) && resizable)
      {
        mouse.img=cDiagSize;
      }
    else if (GetMouseX()>=plotx(w-2) && resizable) {mouse.img=cHorSize;}
    else if (GetMouseY()>=ploty(h-2) && resizable) {mouse.img=cVertSize;}
  }
}

Window.prototype.__mouseUp = function ()
{
  //if (this.dragging)
  {
    this.dragging=false;
    mouse.drop();
  }
}